angular.module('focaCrearRemito')
    .controller('focaRemitoComprobanteController', [
        '$scope',
        '$uibModalInstance',
        'crearRemitoService',
        '$window',
        '$filter',
        'parametros',
        'FileSaver',
        'Blob',
        function(
            $scope, $uibModalInstance, crearRemitoService, $window, $filter,
            parametros, FileSaver, Blob
        ) {
            $scope.correoEnviado = false;
            $scope.correoNoEnviado = false;
            $scope.esperando = false;
            $scope.remito = parametros.remito;

            $scope.aceptar = function() {
                $uibModalInstance.close();
            };

            $scope.imprimir = function () {
                crearRemitoService.imprimirRemitoByIdRemito($scope.remito.id).then(
                    function(res) {
                        var data = new Blob([res.data], {type: 'application/pdf'});
                        
                        FileSaver.saveAs(
                            data, 
                            $filter('comprobante')([
                                parametros.remito.sucursal, 
                                parametros.remito.numeroRemito
                            ]) + '.pdf'
                        );
                    }
                );
            };

            $scope.enviarCorreo = function(key) {
                if(key !== 13) return;
                $scope.esperando = true;
                var options = {
                    para: $scope.remito.cliente.MAIL,
                    remito: $scope.remito.id
                };

                crearRemitoService.enviarCorreo(options).then(function() {
                    $scope.correoEnviado = true;
                    $scope.esperando = false;
                }, function() {
                    $scope.esperando = false;
                    $scope.correoNoEnviado = true;
                });
            };
        }
    ]);
